﻿/*photocorners2.1
boriskasmoscow@gmail.com
adobeindesign.ru
31.01.2018
В данной версии устранено образование черного овала
*/
Document.prototype.getUnits = function()
{
return([
	this.viewPreferences.horizontalMeasurementUnits,
	this.viewPreferences.verticalMeasurementUnits
	]);
}

Document.prototype.setUnitsTo = function(newHUnits, newVUnits)
{
with(this.viewPreferences)
	{
	horizontalMeasurementUnits = newHUnits;
	verticalMeasurementUnits = newVUnits;
	}
}
//--------------------------------------------------------------------------------------------
//var appVersion = parseInt(app.version);
//if(appVersion<6){main();}
//else{app.doScript (main, ScriptLanguage.JAVASCRIPT, [], UndoModes.ENTIRE_SCRIPT, "photoCorners2")}
//--------------------------------------------------------------------------------------------
main();

function main(){
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
	var myObjectList = new Array;
	if (app.documents.length != 0){
		if (app.selection.length != 0){

			for(var myCounter = 0; myCounter < app.selection.length; myCounter++){
				if(app.selection[myCounter].constructor.name == "Rectangle") {
                    myObjectList.push(app.selection[myCounter]);
                    }                
                } // for
			if (myObjectList.length != 0){
                    var units = app.activeDocument.getUnits();
                    app.activeDocument.setUnitsTo(MeasurementUnits.points, MeasurementUnits.points);
                    photoCorners(myObjectList);
                    app.activeDocument.setUnitsTo(units[0], units[1]);
			}
			else{
				alert ("Пожалуйста выделите прямоугольник(и) и запустите скрипт снова");
			}
		}
		else{
			alert ("Пожалуйста выделите прямоугольник(и) и запустите скрипт снова");
		}
	}
	else{
		alert ("Пожалуйста откройте документ, выделите прямоугольник и запустите скрипт снова");
	}
}// main

function photoCorners(myObjects)
{
  // Расшифровка сокращений в переменных: TLCorner = Top Left Corner, BRCorner = Bottom Right Corner, etc.    
   var WhiteCant = 10;
   var myDoc = app.activeDocument;
   var myGroups=[];
   var TLBounds = [];
   var myDiametr = 50;
   var myoffset = 0;
   var myWhiteColor = myAddColor(myDoc, "WhiteColor", ColorModel.process, [0, 0, 0, 0]);
   var myBackGroundColor = myAddColor(myDoc, "BackGroundColor", ColorModel.process, [0, 0, 0, 20]);
   var myShadowColor = myAddColor(myDoc, "Gray65", ColorModel.process, [0, 0, 0, 65]);
   var myGroups = [] ;
   var myObjGroups= [];
// Создание 4-х уголков
    // Цикл по выделенным объектам
   for(var i = 0; i < myObjects.length; i++)
   {
       var myObj = myObjects[i];
       var myPage = myObj.parentPage;
       var myBounds = myObj.geometricBounds;
       var myWhiteRec = myObj.duplicate();
       myWhiteRec = removeGraphics(myWhiteRec);
       myWhiteRec = removeGraphics(myWhiteRec);
       myWhiteRec.resize(CoordinateSpaces.innerCoordinates, AnchorPoint.centerAnchor, ResizeMethods.ADDING_CURRENT_DIMENSIONS_TO, [2*WhiteCant, 2*WhiteCant]);
       myWhiteRec.fillColor = myWhiteColor;
       myWhiteRec.sendToBack();
       myGrayRec = myWhiteRec.duplicate();
       myGrayRec.resize(CoordinateSpaces.innerCoordinates, AnchorPoint.centerAnchor, ResizeMethods.ADDING_CURRENT_DIMENSIONS_TO, [3, 3]);
       myGrayRec.fillColor = myShadowColor;
       myGrayRec.transparencySettings.blendingSettings.blendMode = BlendMode.MULTIPLY;
       myGrayRec.sendToBack();
       with (myGrayRec.transparencySettings.directionalFeatherSettings){  
          applied = true;  
          angle = 0;  
          noise = 0;  
          chokeAmount = 0;  
          followShapeMode = FollowShapeModeOptions.ALL_EDGES;  
          bottomWidth = 2;  
          topWidth = 2;
          rightWidth = 2;
          leftWidth = 2;
        }
       //
       
       var myCorners = makeCorners (myDoc, myPage, myDiametr, myoffset, myBounds);
       
      var myBackGround = myWhiteRec.duplicate();
       myBackGround.fillColor= myBackGroundColor;
       myBackGround.sendToBack();       
       myBackGround.resize(CoordinateSpaces.innerCoordinates, AnchorPoint.centerAnchor, ResizeMethods.ADDING_CURRENT_DIMENSIONS_TO, [myDiametr+myoffset, myDiametr+myoffset]);
       //myObjGroups[i]  = myDoc.groups.add([myObj, myWhiteRec,myGrayRec, myBackGround]);
       //myGroups[i]  = myDoc.groups.add(myCorners);

   }
    
} // fnc

/*************************************************************************/
function makeCorners (myDoc, myCurrentPage, myDiam, sdvig, objBounds)
{
    var radius = myDiam/2;
    var myCorners= [];
    
// Создание цветов и градиентов
    var myColor1 = myAddColor(myDoc, "Gray0", ColorModel.process, [0, 0, 0, 0]);
    var myColor2 = myAddColor(myDoc, "Gray5", ColorModel.process, [0, 0, 0, 5]);
	var myColor3 = myAddColor(myDoc, "Gray20", ColorModel.process, [0, 0, 0, 20]);    
    var myColor4 = myAddColor(myDoc, "Gray40", ColorModel.process, [0, 0, 0, 40]); 
    var myColor5 = myAddColor(myDoc, "Gray25", ColorModel.process, [0, 0, 0, 25]); 
    var myColor6 = myAddColor(myDoc, "Gray65", ColorModel.process, [0, 0, 0, 65]);
    
    
    var  dopStopColorsTop = new Array({'loc':50, 'col':myColor3},{'loc':77, 'col':myColor2});
    var TGradient = myAddGradient(myDoc, 'Top', GradientType.LINEAR, [myColor3, myColor2], dopStopColorsTop);
    
    var  dopStopColorsTop = new Array({'loc':25, 'col':myColor5},{'loc':50, 'col':myColor3});
    var BGradient = myAddGradient(myDoc, 'Bottom', GradientType.LINEAR, [myColor4, myColor3], dopStopColorsTop);
    
    //var  dopStopColorsBottom = new Array({'loc':50, 'col':myColor3}, {'loc':77, 'col':myColor2});
    //var myGradientBottom = myAddGradient(myDoc, 'Gr2', GradientType.LINEAR, [myColor3, myColor2], dopStopColorsBottom);
    // цикл по 4 вершинам прямоугольника
    for (var i=0; i< 4; i++)
    {
        switch (i){
            case 0: // Левый верхний угол
                var y0 = objBounds[0] - radius + sdvig;
                var x0 = objBounds[1] - radius + sdvig;
                var y1 = objBounds[0] + radius + sdvig;
                var x1 = objBounds[1] + radius + sdvig;
                var TLOval = myCurrentPage.ovals.add({geometricBounds: [y0,x0,y1,x1], fillColor: TGradient, strokeWeight: 0 });
                var myRotateMatrix = app.transformationMatrices.add({counterclockwiseRotationAngle:-45});
                TLOval.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.centerAnchor, myRotateMatrix);
                myCorners.push(TLOval);
                
                // Делаем серый овал
                var TLGOval = TLOval.duplicate();
                TLGOval.move(undefined,[3,3],true);
                TLGOval.fillColor = myColor6;
                TLGOval.sendBackward();
                TLGOval.transparencySettings.blendingSettings.blendMode = BlendMode.MULTIPLY;
                with (TLGOval.transparencySettings.directionalFeatherSettings){  
                  applied = true;  
                  angle = 0;  
                  noise = 0;  
                  chokeAmount = 0;  
                  followShapeMode = FollowShapeModeOptions.ALL_EDGES;  
                  bottomWidth = 2;  
                  topWidth = 2;
                  rightWidth = 2;
                  leftWidth = 2;
                }
                myCorners.push(TLGOval);
                
                // Делаем белый овал
                var TLWOval = TLOval.duplicate();
                TLWOval.move(undefined,[1,1],true);
                TLWOval.fillColor = myColor1;
                TLWOval.sendBackward(); 
                myCorners.push(TLWOval);
                
                // Делаем черный овал
                var TLBOval = TLOval.duplicate();
                TLBOval.move(undefined,[3,3],true);
                TLBOval.fillColor = myDoc.swatches.item("Black");
                TLBOval.sendToBack();
                myCorners.push(TLBOval);
                break;
            
            case 1: // Правый верхний угол
                var y0 = objBounds[0] - radius + sdvig;
                var x0 = objBounds[3] - radius - sdvig;
                var y1 = objBounds[0] + radius + sdvig;
                var x1 = objBounds[3] + radius - sdvig;
                var TROval = myCurrentPage.ovals.add({geometricBounds: [y0,x0,y1,x1], fillColor: TGradient, strokeWeight: 0 });
                 var myRotateMatrix = app.transformationMatrices.add({counterclockwiseRotationAngle:-135});
                TROval.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.centerAnchor, myRotateMatrix);
                myCorners.push(TROval);
                
                // Делаем серый овал
                var TRGOval = TROval.duplicate();
                TRGOval.move(undefined,[-3,3],true);
                TRGOval.fillColor = myColor6;
                TRGOval.sendBackward();
                TRGOval.transparencySettings.blendingSettings.blendMode = BlendMode.MULTIPLY;
                with (TRGOval.transparencySettings.directionalFeatherSettings){  
                  applied = true;  
                  angle = 0;  
                  noise = 0;  
                  chokeAmount = 0;  
                  followShapeMode = FollowShapeModeOptions.ALL_EDGES;  
                  bottomWidth = 2;  
                  topWidth = 2;
                  rightWidth = 2;
                  leftWidth = 2;
                }
                myCorners.push(TRGOval);
                
                // Делаем белый овал
                var TRWOval = TROval.duplicate();
                TRWOval.move(undefined,[-1,1],true);
                TRWOval.fillColor = myColor1;
                TRWOval.sendBackward();
                myCorners.push(TRWOval);
                
                // Делаем черный овал
                var TRBOval = TROval.duplicate();
                TRBOval.move(undefined,[-3,3],true);
                TRBOval.fillColor = myDoc.swatches.item("Black");
                TRBOval.sendToBack();
                myCorners.push(TRBOval);
                break;
                
            case 2: // Правый нижний  угол
                var y0 = objBounds[2] - radius - sdvig;
                var x0 = objBounds[3] - radius - sdvig;
                var y1 = objBounds[2] + radius - sdvig;
                var x1 = objBounds[3] + radius - sdvig;
                var BROval = myCurrentPage.ovals.add({geometricBounds: [y0,x0,y1,x1], fillColor: BGradient, strokeWeight: 0});
                var myRotateMatrix = app.transformationMatrices.add({counterclockwiseRotationAngle:-45});
                BROval.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.centerAnchor, myRotateMatrix);
                myCorners.push(BROval);
                
                 // Делаем серый овал
                var BRGOval = BROval.duplicate();
                BRGOval.move(undefined,[-3,-3],true);
                BRGOval.fillColor = myColor6; // белый
                BRGOval.sendBackward();
                BRGOval.transparencySettings.blendingSettings.blendMode = BlendMode.MULTIPLY;
                with (BRGOval.transparencySettings.directionalFeatherSettings){  
                  applied = true;  
                  angle = 0;  
                  noise = 0;  
                  chokeAmount = 0;  
                  followShapeMode = FollowShapeModeOptions.ALL_EDGES;  
                  bottomWidth = 2;  
                  topWidth = 2;
                  rightWidth = 2;
                  leftWidth = 2;
                }
                myCorners.push(BRGOval);

                // Делаем белый овал
                var BRWOval = BROval.duplicate();
                BRWOval.move(undefined,[-1,-1],true);
                BRWOval.fillColor = myColor1; // белый
                BRWOval.sendBackward();
                myCorners.push(BRWOval);
                
                // Делаем черный овал
                var BRBOval = BROval.duplicate();
                BRBOval.move(undefined,[-3,-3],true);
                BRBOval.fillColor = myDoc.swatches.item("Black");
                BRBOval.sendToBack(); 
                myCorners.push(BRBOval);
                break;
            
            case 3: // Левый нижний  угол
                var y0 = objBounds[2] - radius - sdvig;
                var x0 = objBounds[1] - radius + sdvig;
                var y1 = objBounds[2] + radius - sdvig;
                var x1 = objBounds[1] + radius + sdvig;
                var BLOval = myCurrentPage.ovals.add({geometricBounds: [y0,x0,y1,x1], fillColor: BGradient, strokeWeight: 0 });
                var myRotateMatrix = app.transformationMatrices.add({counterclockwiseRotationAngle:-135});
                BLOval.transform(CoordinateSpaces.pasteboardCoordinates, AnchorPoint.centerAnchor, myRotateMatrix);
                myCorners.push(BLOval);
                
                // Делаем серый овал
                var BLGOval = BLOval.duplicate();
                BLGOval.move(undefined,[3,-3],true);
                BLGOval.fillColor = myColor6; // серый 65
                BLGOval.sendBackward();
                BLGOval.transparencySettings.blendingSettings.blendMode = BlendMode.MULTIPLY;
                with (BLGOval.transparencySettings.directionalFeatherSettings){  
                  applied = true;  
                  angle = 0;  
                  noise = 0;  
                  chokeAmount = 0;  
                  followShapeMode = FollowShapeModeOptions.ALL_EDGES;  
                  bottomWidth = 2;  
                  topWidth = 2;
                  rightWidth = 2;
                  leftWidth = 2;
                }
                myCorners.push(BLGOval);

                // Делаем белый овал
                var BLWOval = BLOval.duplicate();
                BLWOval.move(undefined,[1,-1],true);
                BLWOval.fillColor = myColor1; // белый
                BLWOval.sendBackward();
                myCorners.push(BLWOval);
                
                // Делаем черный овал
                var BLBOval = BLOval.duplicate();
                BLBOval.move(undefined,[3,-3],true);
                BLBOval.fillColor = myDoc.swatches.item("Black");
                BLBOval.sendToBack();
                myCorners.push(BLBOval);

                break;
                default: break;
            } // switch

    } // for
// 
 
return myCorners;    
} // fnc

function removeGraphics(myObj)
{
     var myGraphics = myObj.allGraphics;
        for (var j = myGraphics.length-1; j > -1; j--)
            try {myGraphics[j].remove()} catch (_){}
return    myObj;
} // fnc

function myAddColor(myDocument, myColorName, myColorModel, myColorValue){
	try{
		var myColor = myDocument.colors.item(myColorName);
		var myName = myColor.name;
	}
	catch (myError){
		myColor = myDocument.colors.add();
        myColor.properties = {name:myColorName, model:myColorModel, colorValue:myColorValue};
	}
	
    return myColor;
} // fnc

///// Функция добавления градиента в документ
function myAddGradient(myDocument, myGrName, myGrType, myStopColor, myDopStopColor){
    try{
            var myGradient = myDocument.gradients.item(myGrName);
            var myName = myGradient.name;            
        }
    catch(myError) {
            var myGradient = myDocument.gradients.add({name: myGrName, type:myGrType});
            for( var i =0; i<myStopColor.length; i++)
            {
                myGradient.gradientStops[i].stopColor = myStopColor[i];
            }
            for( var i =0; i<myDopStopColor.length; i++)
            {
                myGradient.gradientStops.add({location:myDopStopColor[i].loc, stopColor:myDopStopColor[i].col}); 
            }
        } // catch
    
    return myGradient;
} // fnc

